SbBox2d Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions | List of all members
SbBox2d Class Reference
Base Classes

The SbBox2d class is a 2 dimensional box with double precision corner coordinates.This box class is used by many other classes in Coin for data exchange and storage. It provides two box corners with double precision coordinates, which is among other things useful for representing screen or canvas dimensions in normalized coordinates. More...

`#include <Inventor/SbBox2d.h>`

## Public Member Functions
| SbBox2d (void)
| SbBox2d (double xmin, double ymin, double xmax, double ymax)
| SbBox2d (const SbVec2d &minpoint, const SbVec2d &maxpoint)
| SbBox2d (const SbBox2f &box)
| SbBox2d (const SbBox2s &box)
| SbBox2d (const SbBox2i32 &box)
SbBox2d & | setBounds (double xmin, double ymin, double xmax, double ymax)
SbBox2d & | setBounds (const SbVec2d &minpoint, const SbVec2d &maxpoint)
SbBox2d & | setBounds (const SbBox2f &box)
SbBox2d & | setBounds (const SbBox2s &box)
SbBox2d & | setBounds (const SbBox2i32 &box)
void | getBounds (double &xmin, double &ymin, double &xmax, double &ymax) const
void | getBounds (SbVec2d &minpoint, SbVec2d &maxpoint) const
const SbVec2d & | getMin (void) const
SbVec2d & | getMin (void)
const SbVec2d & | getMax (void) const
SbVec2d & | getMax (void)
void | extendBy (const SbVec2d &point)
void | extendBy (const SbBox2d &box)
void | makeEmpty (void)
SbBool | isEmpty (void) const
SbBool | hasArea (void) const
SbBool | intersect (const SbVec2d &point) const
SbBool | intersect (const SbBox2d &box) const
SbVec2d | getClosestPoint (const SbVec2d &p) const
SbBool | findIntersection (const SbVec2d &a, const SbVec2d &b, SbVec2d &ia, SbVec2d &ib) const
SbVec2d | getCenter (void) const
void | getOrigin (double &originX, double &originY) const
void | getSize (double &sizeX, double &sizeY) const
double | getAspectRatio (void) const

## Related Functions
(Note that these are not member functions.)
int | operator== (const SbBox2d &b1, const SbBox2d &b2)
int | operator!= (const SbBox2d &b1, const SbBox2d &b2)

## Detailed Description

The SbBox2d class is a 2 dimensional box with double precision corner coordinates.

This box class is used by many other classes in Coin for data exchange and storage. It provides two box corners with double precision coordinates, which is among other things useful for representing screen or canvas dimensions in normalized coordinates.

This class is a Coin extension.

See also
  SbBox2s, SbBox2f, SbBox3s, SbBox3f, SbBox3d, SbXfBox3f.

Since
  Coin 2.0
  TGS Inventor 2.6

## Constructor & Destructor Documentation

SbBox2d::SbBox2d | ( | void |  | ) |
| inline

The default constructor makes an empty box.

SbBox2d::SbBox2d | ( | double | xmin,
|  | double | ymin,
|  | double | xmax,
|  | double | ymax
| ) |  |
| inline

Constructs a box with the given corners.

xmin should be less than xmax and ymin should be less than ymax if you want to make a valid box.

SbBox2d::SbBox2d | ( | const SbVec2d & | min,
|  | const SbVec2d & | max
| ) |  |
| inline

Constructs a box with the given lower left and upper right corners.

The coordinates of min should be less than the coordinates of max if you want to make a valid box.

## Member Function Documentation

SbBox2d & SbBox2d::setBounds | ( | double | xmin,
|  | double | ymin,
|  | double | xmax,
|  | double | ymax
| ) |  |
| inline

Reset the boundaries of the box.

xmin should be less than xmax and ymin should be less than ymax if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

SbBox2d & SbBox2d::setBounds | ( | const SbVec2d & | min,
|  | const SbVec2d & | max
| ) |  |
| inline

Reset the boundaries of the box with the given corners.

The coordinates of min should be less than the coordinates of max if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

SbBox2d & SbBox2d::setBounds | ( | const SbBox2f & | box | ) |

Reset the boundaries of the box with the given box boundaries.

Returns reference to self.

See also
  getBounds()

SbBox2d & SbBox2d::setBounds | ( | const SbBox2s & | box | ) |

Reset the boundaries of the box with the given box boundaries.

Returns reference to self.

See also
  getBounds()

SbBox2d & SbBox2d::setBounds | ( | const SbBox2i32 & | box | ) |

Reset the boundaries of the box with the given box boundaries.

Returns reference to self.

See also
  getBounds()

void SbBox2d::getBounds | ( | double & | xmin,
|  | double & | ymin,
|  | double & | xmax,
|  | double & | ymax
| ) |  | const
| inline

Returns the box boundaries.

See also
  setBounds(), getMin(), getMax().

void SbBox2d::getBounds | ( | SbVec2d & | min,
|  | SbVec2d & | max
| ) |  | const
| inline

Returns the box min and max corner points.

See also
  setBounds(), getMin(), getMax().

const SbVec2d & SbBox2d::getMin | ( | void |  | ) | const
| inline

Returns the lower left corner of the box.

See also
  getOrigin(), getMax().

SbVec2d & SbBox2d::getMin | ( | void |  | ) |
| inline

Returns the lower left corner of the box.

See also
  getOrigin(), getMax().

const SbVec2d & SbBox2d::getMax | ( | void |  | ) | const
| inline

Returns the upper right corner of the box.

See also
  getMin().

SbVec2d & SbBox2d::getMax | ( | void |  | ) |
| inline

Returns the upper right corner of the box.

See also
  getMin().

void SbBox2d::extendBy | ( | const SbVec2d & | point | ) |

Extend the boundaries of the box by the given point, i.e. make the box fit around the point if it isn't already situated within it.

void SbBox2d::extendBy | ( | const SbBox2d & | box | ) |

Extend the boundaries of the box by the given box parameter. This is equal to calling the above method twice with the corner points.

void SbBox2d::makeEmpty | ( | void |  | ) |

Marks this as an empty box.

See also
  isEmpty().

SbBool SbBox2d::isEmpty | ( | void |  | ) | const
| inline

Check if this has been marked as an empty box.

See also
  makeEmpty().

SbBool SbBox2d::hasArea | ( | void |  | ) | const
| inline

Check if the box has "positive" area, i.e. the lower left corner is actually lower and more to the left than the other corner point.

SbBool SbBox2d::intersect | ( | const SbVec2d & | point | ) | const

Check if point lies within the boundaries of this box.

SbBool SbBox2d::intersect | ( | const SbBox2d & | box | ) | const

Check if box lies wholly or partly within the boundaries of this box.

SbVec2d SbBox2d::getClosestPoint | ( | const SbVec2d & | p | ) | const

Return the point on the box closest to the given point p.

SbBool SbBox2d::findIntersection | ( | const SbVec2d & | a,
|  | const SbVec2d & | b,
|  | SbVec2d & | ia,
|  | SbVec2d & | ib
| ) |  | const

Check if a a line from a to b intersects the box, and return the coordinates of the union line in ia and ib.

This function is a Coin extension.

SbVec2d SbBox2d::getCenter | ( | void |  | ) | const
| inline

Returns the center point of the box.

void SbBox2d::getOrigin | ( | double & | originX,
|  | double & | originY
| ) |  | const
| inline

Returns the coordinates of the box origin (i.e. the lower left corner).

See also
  getMin().

void SbBox2d::getSize | ( | double & | sizeX,
|  | double & | sizeY
| ) |  | const
| inline

Returns width and height of box.

double SbBox2d::getAspectRatio | ( | void |  | ) | const
| inline

Returns aspect ratio of box, which is defined as box width divided on box height.

## Friends And Related Function Documentation

int operator== | ( | const SbBox2d & | b1,
|  | const SbBox2d & | b2
| ) |  |
| related

Check b1 and b2 for equality.

int operator!= | ( | const SbBox2d & | b1,
|  | const SbBox2d & | b2
| ) |  |
| related

Check b1 and b2 for inequality.

The documentation for this class was generated from the following files:

- SbBox2d.h
- SbBox2d.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.